diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/mpi/examples/simple-distributed-empty-node.cc ns-3.31/src/mpi/examples/simple-distributed-empty-node.cc
--- ns-3.30.1/src/mpi/examples/simple-distributed-empty-node.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/mpi/examples/simple-distributed-empty-node.cc	2020-06-27 17:38:30.000000000 -0700
@@ -66,10 +66,7 @@
 #include "ns3/ipv4-address-helper.h"
 #include "ns3/on-off-helper.h"
 #include "ns3/packet-sink-helper.h"
-
-#ifdef NS3_MPI
 #include <mpi.h>
-#endif
 
 using namespace ns3;
 
@@ -78,14 +75,12 @@
 int
 main (int argc, char *argv[])
 {
-#ifdef NS3_MPI
-
   bool nix = true;
   bool nullmsg = false;
   bool tracing = false;
 
   // Parse command line
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue ("nix", "Enable the use of nix-vector or global routing", nix);
   cmd.AddValue ("nullmsg", "Enable the use of null-message synchronization", nullmsg);
   cmd.AddValue ("tracing", "Enable pcap tracing", tracing);
@@ -295,7 +290,4 @@
   // Exit the MPI execution environment
   MpiInterface::Disable ();
   return 0;
-#else
-  NS_FATAL_ERROR ("Can't use distributed simulator without MPI compiled in");
-#endif
 }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/mpi/examples/third-distributed.cc ns-3.31/src/mpi/examples/third-distributed.cc
--- ns-3.30.1/src/mpi/examples/third-distributed.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/mpi/examples/third-distributed.cc	2020-06-27 17:38:30.000000000 -0700
@@ -54,7 +54,7 @@
   bool tracing = false;
   bool nullmsg = false;
 
-  CommandLine cmd;
+  CommandLine cmd (__FILE__);
   cmd.AddValue ("nCsma", "Number of \"extra\" CSMA nodes/devices", nCsma);
   cmd.AddValue ("nWifi", "Number of wifi STA devices", nWifi);
   cmd.AddValue ("verbose", "Tell echo applications to log if true", verbose);
@@ -82,8 +82,6 @@
   uint32_t systemId = 0;
   uint32_t systemCount = 1;
 
-#ifdef NS3_MPI
-
   // Distributed simulation setup; by default use granted time window algorithm.
   if(nullmsg) 
     {
@@ -109,8 +107,6 @@
       return 1;
     }
 
-#endif // NS3_MPI
-
   // System id of Wifi side
   uint32_t systemWifi = 0;
   
@@ -262,10 +258,8 @@
   Simulator::Run ();
   Simulator::Destroy ();
 
-#ifdef NS3_MPI
   // Exit the MPI execution environment
   MpiInterface::Disable ();
-#endif
   
   return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/mpi/examples/wscript ns-3.31/src/mpi/examples/wscript
--- ns-3.30.1/src/mpi/examples/wscript	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/mpi/examples/wscript	2020-06-27 17:38:30.000000000 -0700
@@ -2,17 +2,17 @@
 
 def build(bld):
     obj = bld.create_ns3_program('simple-distributed',
-                                 ['point-to-point', 'internet', 'nix-vector-routing', 'applications'])
+                                 ['mpi', 'point-to-point', 'internet', 'nix-vector-routing', 'applications'])
     obj.source = 'simple-distributed.cc'
 
     obj = bld.create_ns3_program('third-distributed',
-                                 ['point-to-point', 'internet', 'mobility', 'wifi', 'csma', 'applications'])
+                                 ['mpi', 'point-to-point', 'internet', 'mobility', 'wifi', 'csma', 'applications'])
     obj.source = 'third-distributed.cc'
 
     obj = bld.create_ns3_program('nms-p2p-nix-distributed',
-                                 ['point-to-point', 'internet', 'nix-vector-routing', 'applications'])
+                                 ['mpi', 'point-to-point', 'internet', 'nix-vector-routing', 'applications'])
     obj.source = 'nms-p2p-nix-distributed.cc'
 
     obj = bld.create_ns3_program('simple-distributed-empty-node',
-                                 ['point-to-point', 'internet', 'nix-vector-routing', 'applications'])
+                                 ['mpi', 'point-to-point', 'internet', 'nix-vector-routing', 'applications'])
     obj.source = 'simple-distributed-empty-node.cc'
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/mpi/model/distributed-simulator-impl.cc ns-3.31/src/mpi/model/distributed-simulator-impl.cc
--- ns-3.30.1/src/mpi/model/distributed-simulator-impl.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/mpi/model/distributed-simulator-impl.cc	2020-06-27 17:38:30.000000000 -0700
@@ -31,11 +31,8 @@
 #include "ns3/assert.h"
 #include "ns3/log.h"
 
-#include <cmath>
-
-#ifdef NS3_MPI
 #include <mpi.h>
-#endif
+#include <cmath>
 
 namespace ns3 {
 
@@ -93,17 +90,12 @@
 {
   NS_LOG_FUNCTION (this);
 
-#ifdef NS3_MPI
   m_myId = MpiInterface::GetSystemId ();
   m_systemCount = MpiInterface::GetSize ();
 
   // Allocate the LBTS message buffer
   m_pLBTS = new LbtsMessage[m_systemCount];
   m_grantedTime = Seconds (0);
-#else
-  NS_UNUSED (m_systemCount);
-  NS_FATAL_ERROR ("Can't use distributed simulator without MPI compiled in");
-#endif
 
   m_stop = false;
   m_globalFinished = false;
@@ -166,7 +158,6 @@
 {
   NS_LOG_FUNCTION (this);
 
-#ifdef NS3_MPI
   if (MpiInterface::GetSize () <= 1)
     {
       m_lookAhead = Seconds (0);
@@ -276,10 +267,6 @@
       m_lookAhead = Time (recvbuf);
       m_grantedTime = m_lookAhead;
     }
-
-#else
-  NS_FATAL_ERROR ("Can't use distributed simulator without MPI compiled in");
-#endif
 }
 
 void
@@ -372,7 +359,6 @@
 {
   NS_LOG_FUNCTION (this);
 
-#ifdef NS3_MPI
   CalculateLookAhead ();
   m_stop = false;
   m_globalFinished = false;
@@ -446,9 +432,6 @@
   // If the simulator stopped naturally by lack of events, make a
   // consistency test to check that we didn't lose any events along the way.
   NS_ASSERT (!m_events->IsEmpty () || m_unscheduledEvents == 0);
-#else
-  NS_FATAL_ERROR ("Can't use distributed simulator without MPI compiled in");
-#endif
 }
 
 uint32_t DistributedSimulatorImpl::GetSystemId () const
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/mpi/model/granted-time-window-mpi-interface.cc ns-3.31/src/mpi/model/granted-time-window-mpi-interface.cc
--- ns-3.30.1/src/mpi/model/granted-time-window-mpi-interface.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/mpi/model/granted-time-window-mpi-interface.cc	2020-06-27 17:38:30.000000000 -0700
@@ -36,9 +36,7 @@
 #include "ns3/nstime.h"
 #include "ns3/log.h"
 
-#ifdef NS3_MPI
 #include <mpi.h>
-#endif
 
 namespace ns3 {
 
@@ -67,13 +65,11 @@
   m_buffer = buffer;
 }
 
-#ifdef NS3_MPI
 MPI_Request*
 SentBuffer::GetRequest ()
 {
   return &m_request;
 }
-#endif
 
 uint32_t              GrantedTimeWindowMpiInterface::m_sid = 0;
 uint32_t              GrantedTimeWindowMpiInterface::m_size = 1;
@@ -83,10 +79,8 @@
 uint32_t              GrantedTimeWindowMpiInterface::m_txCount = 0;
 std::list<SentBuffer> GrantedTimeWindowMpiInterface::m_pendingTx;
 
-#ifdef NS3_MPI
 MPI_Request* GrantedTimeWindowMpiInterface::m_requests;
 char**       GrantedTimeWindowMpiInterface::m_pRxBuffers;
-#endif
 
 TypeId 
 GrantedTimeWindowMpiInterface::GetTypeId (void)
@@ -103,7 +97,6 @@
 {
   NS_LOG_FUNCTION (this);
 
-#ifdef NS3_MPI
   for (uint32_t i = 0; i < GetSize (); ++i)
     {
       delete [] m_pRxBuffers[i];
@@ -112,7 +105,6 @@
   delete [] m_requests;
 
   m_pendingTx.clear ();
-#endif
 }
 
 uint32_t
@@ -165,7 +157,6 @@
 {
   NS_LOG_FUNCTION (this << pargc << pargv); 
 
-#ifdef NS3_MPI
   // Initialize the MPI interface
   MPI_Init (pargc, pargv);
   MPI_Barrier (MPI_COMM_WORLD);
@@ -182,9 +173,6 @@
       MPI_Irecv (m_pRxBuffers[i], MAX_MPI_MSG_SIZE, MPI_CHAR, MPI_ANY_SOURCE, 0,
                  MPI_COMM_WORLD, &m_requests[i]);
     }
-#else
-  NS_FATAL_ERROR ("Can't use distributed simulator without MPI compiled in");
-#endif
 }
 
 void
@@ -192,7 +180,6 @@
 {
   NS_LOG_FUNCTION (this << p << rxTime.GetTimeStep () << node << dev);
 
-#ifdef NS3_MPI
   SentBuffer sendBuf;
   m_pendingTx.push_back (sendBuf);
   std::list<SentBuffer>::reverse_iterator i = m_pendingTx.rbegin (); // Points to the last element
@@ -217,9 +204,6 @@
   MPI_Isend (reinterpret_cast<void *> (i->GetBuffer ()), serializedSize + 16, MPI_CHAR, nodeSysId,
              0, MPI_COMM_WORLD, (i->GetRequest ()));
   m_txCount++;
-#else
-  NS_FATAL_ERROR ("Can't use distributed simulator without MPI compiled in");
-#endif
 }
 
 void
@@ -227,7 +211,6 @@
 { 
   NS_LOG_FUNCTION_NOARGS ();
 
-#ifdef NS3_MPI
   // Poll the non-block reads to see if data arrived
   while (true)
     {
@@ -281,9 +264,6 @@
       MPI_Irecv (m_pRxBuffers[index], MAX_MPI_MSG_SIZE, MPI_CHAR, MPI_ANY_SOURCE, 0,
                  MPI_COMM_WORLD, &m_requests[index]);
     }
-#else
-  NS_FATAL_ERROR ("Can't use distributed simulator without MPI compiled in");
-#endif
 }
 
 void
@@ -291,7 +271,6 @@
 {
   NS_LOG_FUNCTION_NOARGS ();
 
-#ifdef NS3_MPI
   std::list<SentBuffer>::iterator i = m_pendingTx.begin ();
   while (i != m_pendingTx.end ())
     {
@@ -305,9 +284,6 @@
           m_pendingTx.erase (current);
         }
     }
-#else
-  NS_FATAL_ERROR ("Can't use distributed simulator without MPI compiled in");
-#endif
 }
 
 void
@@ -315,7 +291,6 @@
 {
   NS_LOG_FUNCTION_NOARGS ();
 
-#ifdef NS3_MPI
   int flag = 0;
   MPI_Initialized (&flag);
   if (flag)
@@ -328,9 +303,6 @@
     {
       NS_FATAL_ERROR ("Cannot disable MPI environment without Initializing it first");
     }
-#else
-  NS_FATAL_ERROR ("Can't use distributed simulator without MPI compiled in");
-#endif
 }
 
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/mpi/model/granted-time-window-mpi-interface.h ns-3.31/src/mpi/model/granted-time-window-mpi-interface.h
--- ns-3.30.1/src/mpi/model/granted-time-window-mpi-interface.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/mpi/model/granted-time-window-mpi-interface.h	2020-06-27 17:38:30.000000000 -0700
@@ -31,11 +31,7 @@
 
 #include "parallel-communication-interface.h"
 
-#ifdef NS3_MPI
 #include "mpi.h"
-#else
-typedef void* MPI_Request;
-#endif
 
 namespace ns3 {
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/mpi/model/null-message-mpi-interface.cc ns-3.31/src/mpi/model/null-message-mpi-interface.cc
--- ns-3.30.1/src/mpi/model/null-message-mpi-interface.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/mpi/model/null-message-mpi-interface.cc	2020-06-27 17:38:30.000000000 -0700
@@ -33,9 +33,7 @@
 #include "ns3/simulator.h"
 #include "ns3/log.h"
 
-#ifdef NS3_MPI
 #include <mpi.h>
-#endif
 
 #include <iostream>
 #include <iomanip>
@@ -49,9 +47,7 @@
  * maximum MPI message size for easy
  * buffer creation
  */
-#ifdef NS3_MPI
 const uint32_t NULL_MESSAGE_MAX_MPI_MSG_SIZE = 2000;
-#endif
 
 NullMessageSentBuffer::NullMessageSentBuffer ()
 {
@@ -95,14 +91,6 @@
 NullMessageMpiInterface::NullMessageMpiInterface ()
 {
   NS_LOG_FUNCTION (this);
-
-#ifndef NS3_MPI
-  /*
-   * This class can only be constructed if MPI is available.  Fail if an 
-   * attempt is made to instantiate this class without MPI.
-   */
-  NS_FATAL_ERROR ("Must compile with MPI if Null Message simulator is used, see --enable-mpi option for waf");
-#endif
 }
 
 NullMessageMpiInterface::~NullMessageMpiInterface ()
@@ -146,10 +134,6 @@
 {
   NS_LOG_FUNCTION (this << *pargc);
 
-#ifndef NS3_MPI
-  NS_UNUSED(pargv);
-#else
-
   // Initialize the MPI interface
   MPI_Init (pargc, pargv);
   MPI_Barrier (MPI_COMM_WORLD);
@@ -165,15 +149,12 @@
 
   g_enabled = true;
   g_initialized = true;
-
-#endif
 }
 
 void 
 NullMessageMpiInterface::InitializeSendReceiveBuffers(void)
 {
   NS_LOG_FUNCTION_NOARGS ();
-#ifdef NS3_MPI
   NS_ASSERT (g_enabled);
 
   g_numNeighbors = RemoteChannelBundleManager::Size();
@@ -193,7 +174,6 @@
           ++index;
         }
     }
-#endif
 }
 
 void
@@ -203,8 +183,6 @@
 
   NS_ASSERT (g_enabled);
 
-#ifdef NS3_MPI
-
   // Find the system id for the destination node
   Ptr<Node> destNode = NodeList::GetNode (node);
   uint32_t nodeSysId = destNode->GetSystemId ();
@@ -235,8 +213,6 @@
              0, MPI_COMM_WORLD, (iter->GetRequest ()));
 
   NullMessageSimulatorImpl::GetInstance ()->RescheduleNullMessageEvent (nodeSysId);
-
-#endif
 }
 
 void
@@ -246,8 +222,6 @@
 
   NS_ASSERT (g_enabled);
 
-#ifdef NS3_MPI
-
   NullMessageSentBuffer sendBuf;
   g_pendingTx.push_back (sendBuf);
   std::list<NullMessageSentBuffer>::reverse_iterator iter = g_pendingTx.rbegin (); // Points to the last element
@@ -268,7 +242,6 @@
 
   MPI_Isend (reinterpret_cast<void *> (iter->GetBuffer ()), bufferSize, MPI_CHAR, nodeSysId,
              0, MPI_COMM_WORLD, (iter->GetRequest ()));
-#endif
 }
 
 void
@@ -296,8 +269,6 @@
 
   NS_ASSERT (g_enabled);
 
-#ifdef NS3_MPI
-
   // stop flag set to true when no more messages are found to
   // process.
   bool stop = false;
@@ -387,7 +358,6 @@
         }
     }
   while (!stop);
-#endif
 }
 
 void
@@ -397,7 +367,6 @@
 
   NS_ASSERT (g_enabled);
 
-#ifdef NS3_MPI
   std::list<NullMessageSentBuffer>::iterator iter = g_pendingTx.begin ();
   while (iter != g_pendingTx.end ())
     {
@@ -411,7 +380,6 @@
           g_pendingTx.erase (current);
         }
     }
-#endif
 }
 
 void
@@ -419,7 +387,6 @@
 {
   NS_LOG_FUNCTION (this);
 
-#ifdef NS3_MPI
   int flag = 0;
   MPI_Initialized (&flag);
   if (flag)
@@ -458,7 +425,6 @@
     {
       NS_FATAL_ERROR ("Cannot disable MPI environment without Initializing it first");
     }
-#endif
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/mpi/model/null-message-mpi-interface.h ns-3.31/src/mpi/model/null-message-mpi-interface.h
--- ns-3.30.1/src/mpi/model/null-message-mpi-interface.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/mpi/model/null-message-mpi-interface.h	2020-06-27 17:38:30.000000000 -0700
@@ -27,12 +27,7 @@
 #include <ns3/nstime.h>
 #include <ns3/buffer.h>
 
-#ifdef NS3_MPI
 #include "mpi.h"
-#else
-typedef void* MPI_Request;
-#endif
-
 #include <list>
 
 namespace ns3 {
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/mpi/model/null-message-simulator-impl.cc ns-3.31/src/mpi/model/null-message-simulator-impl.cc
--- ns-3.30.1/src/mpi/model/null-message-simulator-impl.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/mpi/model/null-message-simulator-impl.cc	2020-06-27 17:38:30.000000000 -0700
@@ -67,7 +67,6 @@
 
 NullMessageSimulatorImpl::NullMessageSimulatorImpl ()
 {
-#ifdef NS3_MPI
   NS_LOG_FUNCTION (this);
 
   m_myId = MpiInterface::GetSystemId ();
@@ -91,10 +90,6 @@
 
   NS_ASSERT (g_instance == 0);
   g_instance = this;
-
-#else
-  NS_FATAL_ERROR ("Can't use Null Message simulator without MPI compiled in");
-#endif
 }
 
 NullMessageSimulatorImpl::~NullMessageSimulatorImpl ()
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/mpi/model/parallel-communication-interface.h ns-3.31/src/mpi/model/parallel-communication-interface.h
--- ns-3.30.1/src/mpi/model/parallel-communication-interface.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/mpi/model/parallel-communication-interface.h	2020-06-27 17:38:30.000000000 -0700
@@ -30,9 +30,7 @@
 #include <ns3/buffer.h>
 #include <ns3/packet.h>
 
-#if defined(NS3_MPI)
 #include "mpi.h"
-#endif
 
 namespace ns3 {
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/mpi/wscript ns-3.31/src/mpi/wscript
--- ns-3.30.1/src/mpi/wscript	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/mpi/wscript	2020-06-27 17:38:30.000000000 -0700
@@ -31,12 +31,17 @@
             conf.report_optional_feature("mpi", "MPI Support", True, '')            
         else:
             conf.report_optional_feature("mpi", "MPI Support", False, 'mpic++ not found')
+            conf.env['MODULES_NOT_BUILT'].append('mpi')
     else:
         conf.report_optional_feature("mpi", "MPI Support", False, 'option --enable-mpi not selected')
+        conf.env['MODULES_NOT_BUILT'].append('mpi')
 
 
 def build(bld):
-    env = bld.env
+    # Don't do anything for this module if mpi's not enabled.
+    if 'mpi' in bld.env['MODULES_NOT_BUILT']:
+        return
+
     sim = bld.create_ns3_module('mpi', ['core', 'network'])
     sim.source = [
         'model/distributed-simulator-impl.cc',
@@ -57,7 +62,7 @@
         'model/parallel-communication-interface.h', 
         ]
 
-    if env['ENABLE_MPI']:
+    if bld.env['ENABLE_MPI']:
         sim.use.append('MPI')
 
     if bld.env['ENABLE_EXAMPLES']:
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/netanim/bindings/callbacks_list.py ns-3.31/src/netanim/bindings/callbacks_list.py
--- ns-3.30.1/src/netanim/bindings/callbacks_list.py	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/netanim/bindings/callbacks_list.py	2020-06-27 17:38:30.000000000 -0700
@@ -1,3 +1,49 @@
 callback_classes = [
-    ['void', 'ns3::Ptr<ns3::NetDevice>', 'ns3::Ptr<ns3::Packet const>', 'unsigned short', 'ns3::Address const&', 'ns3::Address const&', 'ns3::NetDevice::PacketType', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['ns3::ObjectBase *', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['bool', 'ns3::Ptr<ns3::NetDevice>', 'ns3::Ptr<const ns3::Packet>', 'unsigned short', 'const ns3::Address &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<ns3::NetDevice>', 'ns3::Ptr<const ns3::Packet>', 'unsigned short', 'const ns3::Address &', 'const ns3::Address &', 'ns3::NetDevice::PacketType', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<ns3::NetDevice>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::MobilityModel>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::SpectrumPhy>', 'ns3::Ptr<const ns3::SpectrumPhy>', 'double', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::MobilityModel>', 'ns3::Ptr<const ns3::MobilityModel>', 'double', 'double', 'double', 'double', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<ns3::SpectrumSignalParameters>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::Packet>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<ns3::Packet>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'std::list<ns3::Ptr<ns3::LteControlMessage>, std::allocator<ns3::Ptr<ns3::LteControlMessage> > >', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'unsigned short', 'ns3::Ptr<ns3::SpectrumValue>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::DlInfoListElement_s', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::UlInfoListElement_s', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::PacketBurst>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::PhyReceptionStatParameters', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'unsigned short', 'unsigned short', 'double', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'unsigned short', 'unsigned short', 'ns3::LteUePhy::State', 'ns3::LteUePhy::State', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'unsigned short', 'unsigned short', 'double', 'double', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'unsigned short', 'unsigned short', 'double', 'double', 'bool', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::PhyTransmissionStatParameters', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'unsigned short', 'const std::vector<int, std::allocator<int> > &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'unsigned short', 'unsigned short', 'double', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<ns3::Packet>', 'double', 'ns3::UanTxMode', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<ns3::Packet>', 'double', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::Packet>', 'double', 'ns3::UanTxMode', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<ns3::WifiPsdu>', 'double', 'ns3::WifiTxVector', 'std::vector<bool, std::allocator<bool> >', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<ns3::WifiPsdu>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Time', 'ns3::Time', 'WifiPhyState', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::Packet>', 'double', 'ns3::WifiMode', 'ns3::WifiPreamble', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::Packet>', 'double', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::Packet>', 'ns3::WifiMode', 'ns3::WifiPreamble', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::WifiPsdu>', 'ns3::WifiTxVector', 'double', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::WifiTxVector', 'ns3::Time', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::Packet>', 'ns3::WifiPhyRxfailureReason', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::Packet>', 'unsigned short', 'ns3::WifiTxVector', 'ns3::MpduInfo', 'ns3::SignalNoiseDbm', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::Packet>', 'unsigned short', 'ns3::WifiTxVector', 'ns3::MpduInfo', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::HePreambleParameters', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<ns3::Socket>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['bool', 'ns3::Ptr<ns3::Socket>', 'const ns3::Address &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<ns3::Socket>', 'const ns3::Address &', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<ns3::Socket>', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'const ns3::Ipv4Header &', 'ns3::Ptr<const ns3::Packet>', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::Packet>', 'ns3::Ptr<ns3::Ipv4>', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'const ns3::Ipv4Header &', 'ns3::Ptr<const ns3::Packet>', 'ns3::Ipv4L3Protocol::DropReason', 'ns3::Ptr<ns3::Ipv4>', 'unsigned int', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
 ]
